float g_slice;
texture g_txNoise;
texture g_txMap1;
texture g_txMap2;
texture g_txMap3;
texture g_txMap4;
texture g_txNumPoly;
texture g_txRay;
texture g_txTriTable;
texture g_txIndex;
texture g_txMapDepth;
texture g_txVertex;
float4 g_pos;
float4 g_pos2;
float g_y;
int g_numPolys;

sampler3D NoiseSampler =sampler_state
{
	Texture=<g_txNoise>;
	
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	
	AddressU  = wrap;
	AddressV  = wrap;
};

sampler NumPolySampler=sampler_state
{
	Texture=<g_txNumPoly>;    
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;    
	AddressU  = wrap;
	AddressV  = wrap;
	
};

sampler MapDepthSampler=sampler_state
{
	Texture=<g_txMapDepth>;    
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;      
	AddressU  = border;
	AddressV  = border;
	BorderColor=0;	
};
sampler VertexSampler=sampler_state
{
	Texture=<g_txVertex>;    
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;      
	AddressU  = border;
	AddressV  = border;
	BorderColor=0;
	
};
sampler TriTableSampler=sampler_state
{
	Texture=<g_txTriTable>;    
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;      
	AddressU  = border;
	AddressV  = border;
	BorderColor=0;
	
};
sampler IndexSampler=sampler_state
{
	Texture=<g_txIndex>;    
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;    
	AddressU  = border;
	AddressV  = border;
	BorderColor=0;
	
};

sampler RaySampler=sampler_state
{
	Texture=<g_txRay>;    
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;    
	AddressU  = wrap;
	AddressV  = wrap;
	
};

sampler SumSampler=sampler_state
{
	Texture=<g_txMap1>;    
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;    
	AddressU  = border;
	AddressV  = border;
	BorderColor=0;
	
};
sampler Map1Sampler=sampler_state
{
	Texture=<g_txMap1>;    
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;     
	AddressU  = border;
	AddressV  = border;
	BorderColor=0;
	
};
sampler Map2Sampler=sampler_state
{
	Texture=<g_txMap2>;    
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;    
	AddressU  = border;
	AddressV  = border;
	BorderColor=0;
	
};
sampler Map3Sampler=sampler_state
{
	Texture=<g_txMap3>;    
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;    
	AddressU  = border;
	AddressV  = border;
	BorderColor=0;
	
};
sampler Map4Sampler=sampler_state
{
	Texture=<g_txMap4>;    
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;     
	AddressU  = border;
	AddressV  = border;
	BorderColor=0;
	
};


struct VS_OUTPUT
{
	float4 Pos: POSITION;
	float3 Tex: TEXCOORD0;
};

VS_OUTPUT VS(float4 inPos:POSITION, float2 inTex:TEXCOORD0)
{
	VS_OUTPUT Out=(VS_OUTPUT)0;
	Out.Pos.z = 0;
	Out.Pos.w= 1;
	Out.Pos.xy=inPos.xy;
	Out.Pos.x=inPos.x+g_y/32.0;	
	Out.Tex.x=g_pos.x+(inTex.x*2-0.5);
	Out.Tex.y=(2*g_y/64.0-0.5)+g_pos.y;
	Out.Tex.z=(inTex.y*2-0.5)+g_pos.z;
	return Out;
}

VS_OUTPUT VS2(float4 inPos:POSITION, float2 inTex:TEXCOORD0)
{
	VS_OUTPUT Out=(VS_OUTPUT)0;
	Out.Pos.z = 0;
	Out.Pos.w= 1;
	Out.Pos.xy=inPos.xy;
	Out.Tex.z=0;
	Out.Tex.xy=inTex.xy;
	return Out;
}

VS_OUTPUT VS_sum1(float4 inPos:POSITION, float2 inTex:TEXCOORD0)
{
	VS_OUTPUT Out=(VS_OUTPUT)0;
	Out.Pos.z = 0;
	Out.Pos.w= 1;
	Out.Pos.x = inTex.x*2.00-1.0;
	Out.Pos.y = 1-inTex.y*2.00;
	Out.Tex.xy=inTex.xy;
	return Out;
}
VS_OUTPUT VS_sum2(float4 inPos:POSITION, float2 inTex:TEXCOORD0)
{
	VS_OUTPUT Out=(VS_OUTPUT)0;
	Out.Pos.z = 0;
	Out.Pos.w= 1;
	Out.Pos.x = inTex.x*2.00-1.0;
	Out.Pos.y = 1-inTex.y*2.00;
	Out.Tex.xy=inTex.xy;
	return Out;
}
VS_OUTPUT VS_sum3(float4 inPos:POSITION, float2 inTex:TEXCOORD0)
{
	VS_OUTPUT Out=(VS_OUTPUT)0;
	Out.Pos.z = 0;
	Out.Pos.w= 1;
	Out.Pos.x = inTex.x*2.00-1.0;
	Out.Pos.y = 1-inTex.y*2.00;
	Out.Tex.xy=inTex.xy;
	return Out;
}
VS_OUTPUT VS_sum4(float4 inPos:POSITION, float2 inTex:TEXCOORD0)
{
	VS_OUTPUT Out=(VS_OUTPUT)0;
	Out.Pos.z = 0;
	Out.Pos.w= 1;
	Out.Pos.x = inTex.x*2.00-1.0;
	Out.Pos.y = 1-inTex.y*2.00;
	Out.Tex.xy=0.0;
	return Out;
}
VS_OUTPUT VS_vertex(float4 inPos:POSITION, float2 inTex:TEXCOORD0)
{
	VS_OUTPUT Out=(VS_OUTPUT)0;
	Out.Pos.z = 0;
	Out.Pos.w= 1;
	Out.Pos.x = inTex.x*2.00-1.0;
	Out.Pos.y = 1-inTex.y*2.00;
	Out.Tex.xy=inTex.xy;
	return Out;
}
VS_OUTPUT VS_vertex2(float4 inPos:POSITION, float2 inTex:TEXCOORD0)
{
	VS_OUTPUT Out=(VS_OUTPUT)0;
	Out.Pos.z = 0;
	Out.Pos.w= 1;
	Out.Pos.x = inTex.x*2.00-1.0;
	Out.Pos.y = 1-inTex.y*2.00;
	Out.Tex.xy=inTex.xy;
	return Out;
}

float4 g_p0;
float4 g_p1;
float4 g_p2;
float4 g_p3;
float4 g_p4;
float4 g_p5;


float distanceToSpline(float s, float3 tex)
{
	float3 P = (g_p4.xyz - g_p3.xyz) - (g_p1.xyz - g_p2.xyz);
	float3 Q = (g_p1.xyz - g_p2.xyz) - P;
	float3 R = g_p3.xyz - g_p1.xyz;
	float3 S = g_p2.xyz;

	float s2 = s*s;
	float s3 = s*s*s;
	float3 c = P*s3 + Q*s2 + R*s + S;
	//	static float3 t1=(p3 - p1) / 2.0;
	//	static float3 t2=(p4 - p2) / 2.0;
	//	float3 c = (2*s3 - 3*s2 + 1)*p2 + (-2*s3 + 3*s2)*p3 + (s3 - 2*s2 + s)*t1 + (s3 - s2)*t2;
	return distance(c, tex);
}

float distanceToSpline2(float s, float3 tex)
{
	float3 P = (g_p5.xyz - g_p4.xyz) - (g_p2.xyz - g_p3.xyz);
	float3 Q = (g_p2.xyz - g_p3.xyz) - P;
	float3 R = g_p4.xyz - g_p2.xyz;
	float3 S = g_p3.xyz;

	float s2 = s*s;
	float s3 = s*s*s;
	float3 c = P*s3 + Q*s2 + R*s + S;
	//	static float3 t1=(p3 - p1) / 2.0;
	//	static float3 t2=(p4 - p2) / 2.0;
	//	float3 c = (2*s3 - 3*s2 + 1)*p2 + (-2*s3 + 3*s2)*p3 + (s3 - 2*s2 + s)*t1 + (s3 - s2)*t2;
	return distance(c, tex);
}


float createSpline(float3 tex, float thick)
{
	float s;
	float min_s=0;
	float min_dens=10000;
	for(int i=0; i<10; i++)
	{		
		s=i/10.0;
		float dens = distanceToSpline(s, tex);
		if(dens<min_dens)
		{
			min_s=s;
			min_dens=dens;
		}
	}
	s=min_s;
	float old_dens;
	float density = distanceToSpline(s, tex);
	old_dens=density;
	float step=0.05;
	for(int i=0; i<20; i++)
	{
		s+=step;
		s=min(1,max(0,s));
		density = distanceToSpline(s, tex);
		if(density<old_dens)
		step=step;
		else
		step=-step*0.49;	
		old_dens=density;
	}	
	
	min_s=0;
	min_dens=10000;
	for(int i=0; i<10; i++)
	{		
		s=i/10.0;
		float dens = distanceToSpline2(s, tex);
		if(dens<min_dens)
		{
			min_s=s;
			min_dens=dens;
		}
	}
	float s2;
	s2=min_s;
	float old_dens2;
	float density2 = distanceToSpline2(s2, tex);
	old_dens2=density2;
	float step2=0.05;
	for(int i=0; i<20; i++)
	{
		s2+=step2;
		s2=min(1,max(0,s2));
		density2 = distanceToSpline2(s2, tex);
		if(density2<old_dens2)
		step2=step2;
		else
		step2=-step2*0.49;	
		old_dens2=density2;
	}
	//	old_dens=100000;	
	density = (thick-min(old_dens, old_dens2))*10;		
	return density;	
}

float4 PS(VS_OUTPUT In):COLOR0
{
	float4 outColor;
	float density=0;	

	float3 warp = (tex3D(NoiseSampler,In.Tex*0.05*0.1)*2-1).xyz;	//0.05
	float3 wtex =In.Tex*0.2+ warp * 0.05;//0.5;		
	density=-1;
	density=min(-2,(0.1-length(In.Tex.xy-4))*1)*1.15;
	density+=tex3D(NoiseSampler,wtex*float3(0.2,0.2,0.005)).x;
	density+=tex3D(NoiseSampler,wtex*float3(0.1,0.1,0.003)).y;
	density+=tex3D(NoiseSampler,wtex*float3(0.1,0.1,0.008)).z;
	density+=tex3D(NoiseSampler,wtex*float3(0.1,0.1,0.01)).w;		
	In.Tex.z=max(In.Tex.z-5,0);
	float de=sin(In.Tex.z)*15;
	de=tex3D(NoiseSampler,float3(0.1,0.1,In.Tex.z*0.002)).w*15;
	de=min(15,max(-5,de));
	density+=tex3D(NoiseSampler,wtex*float3(0.5,0.5,0.02)).x*de*0.03;
	density+=tex3D(NoiseSampler,wtex*float3(0.5,0.5,0.01)).w*de*0.03;		
	float3 start=(tex3D(NoiseSampler,float3(0.5,0.5,0.5)).xyz);
	float3 c=In.Tex;

	//		density = max(density,createSpline(c, 0.2)*2);
	//		float leer=-createSpline(c, 0.1)*5;
	//		density = min(density,leer);

	if(In.Tex.z>74.90)
	density=-1;
	outColor=0;
	outColor.r=density;
	return outColor;	
}


float sampleDepth(float2 coord, float3 offset)
{
	float3 pixel={1/4096.0,1/64.0,1/64.0};
	float pz=floor(coord.x*32);
	coord.y*=0.5;
	coord.y+=0.25;
	coord.x*=0.25;
	coord.x+=0.25;
	coord.x+=16*pixel.x;
	coord.x+=pz*32*pixel.x;
	
	coord.x+=offset.x*pixel.x;
	coord.y+=offset.y*pixel.y;
	coord.x+=floor(offset.z)*64*pixel.x;
	return tex2D(Map1Sampler,coord.xy).x;
}
float sampleDepth2(float2 coord, float3 offset)
{
	float3 pixel={1/1024.0,1/32.0,1/32.0};
	
	coord.x+=offset.x*pixel.x;
	coord.y+=offset.y*pixel.y;
	coord.x+=floor(offset.z)*32*pixel.x;
	return tex2D(Map2Sampler,coord.xy).x;
}


float sampleMat(float2 coord, float3 offset)
{
	float3 pixel={1/4096.0,1/64.0,1/64.0};
	float pz=floor(coord.x*32);
	coord.y*=0.5;
	coord.y+=0.25;
	coord.x*=0.25;
	coord.x+=0.25;
	coord.x+=16*pixel.x;
	coord.x+=pz*32*pixel.x;
	
	coord.x+=offset.x*pixel.x;
	coord.y+=offset.y*pixel.y;
	coord.x+=floor(offset.z)*64*pixel.x;
	return tex2D(Map1Sampler,coord.xy).g;
}

float calc_ao(float2 coord)
{
	float visibility=0;
	//return 1;
	float visibility2=0;
	for(int i=0; i<128; i++)
	{
		float3 dir=tex1D(RaySampler,(i+128)/1024.0).xyz*12/20000;
		float dis=length(dir);
		float this_ray_visibility = 1;
		float d = sampleDepth(coord,float3(dir.x,dir.y,dir.z));
		this_ray_visibility=(d>0)?dis/200.f:1;
		visibility2 += this_ray_visibility;
	}
	visibility=visibility2/128.f;	
	return visibility;
}

float4 PS_Cube(VS_OUTPUT In):COLOR0
{
	int index=0;
	float sample[8];
	for(int i=0; i<8; i++)
	{
		sample[i]=0;
	}
	sample[0]=sampleDepth(In.Tex.xy,float3(0,0,0));
	sample[1]=sampleDepth(In.Tex.xy,float3(1,0,0));
	sample[2]=sampleDepth(In.Tex.xy,float3(1,0,1));
	sample[3]=sampleDepth(In.Tex.xy,float3(0,0,1));
	sample[4]=sampleDepth(In.Tex.xy,float3(0,1,0));
	sample[5]=sampleDepth(In.Tex.xy,float3(1,1,0));
	sample[6]=sampleDepth(In.Tex.xy,float3(1,1,1));
	sample[7]=sampleDepth(In.Tex.xy,float3(0,1,1));	
	for(int j=0; j<8; j++)
	{
		if(sample[j]>0)
		index+=pow(2,j);
	}	
	float ao=0;
	if(index>0 && index<255)
	ao=calc_ao(In.Tex.xy);
	float polys=tex2D(NumPolySampler,float2(index/255.0,0.5)).x;
	return float4(polys/255.0,ao,index/255.0,0);
	
	
}

static float2 pixel={1/1024.0,1/32.0};
static float2 pixel2={1/1024.0,1/32.0};

int sumPoly(float2 coord,float offset)
{	
	int sum1=(tex2D(SumSampler,coord+float2(0+offset*pixel.x,0)).x*255+0.1);
	sum1+=(tex2D(SumSampler,coord+float2(pixel.x+offset*pixel.x,0)).x*255+0.1);
	sum1+=(tex2D(SumSampler,coord+float2(0+offset*pixel.x,pixel.y)).x*255+0.1);
	sum1+=(tex2D(SumSampler,coord+float2(pixel.x+offset*pixel.x,pixel.y)).x*255+0.1);
	return sum1;
}
float sumPoly2(float2 coord,float offset)
{	
	float4 tsum=tex2D(SumSampler,coord+float2(0+offset*pixel.x,0));
	float sum1=tsum.x+tsum.y+tsum.z+tsum.w;
	tsum=tex2D(SumSampler,coord+float2(pixel.x+offset*pixel.x,0));
	sum1+=tsum.x+tsum.y+tsum.z+tsum.w;
	tsum=tex2D(SumSampler,coord+float2(0+offset*pixel.x,pixel.y));
	sum1+=tsum.x+tsum.y+tsum.z+tsum.w;
	tsum=tex2D(SumSampler,coord+float2(pixel.x+offset*pixel.x,pixel.y));
	sum1+=tsum.x+tsum.y+tsum.z+tsum.w;
	return sum1;
}


float4 PS_sum1(VS_OUTPUT In):COLOR0
{
	pixel=float2(1/1024.0,1/32.0);
	float sum1=sumPoly(In.Tex.xy,0);
	float sum2=sumPoly(In.Tex.xy,2);
	float sum3=sumPoly(In.Tex.xy,4);
	float sum4=sumPoly(In.Tex.xy,6);
	return float4(sum1,sum2,sum3,sum4);
	
}
float4 PS_sum2(VS_OUTPUT In):COLOR0
{
	pixel=float2(1/128.0,1/16.0);
	float sum1=sumPoly2(In.Tex.xy,0);
	float sum2=sumPoly2(In.Tex.xy,2);
	float sum3=sumPoly2(In.Tex.xy,4);
	float sum4=sumPoly2(In.Tex.xy,6);
	return float4(sum1,sum2,sum3,sum4);
}
float4 PS_sum3(VS_OUTPUT In):COLOR0
{
	pixel=float2(1/16.0,1/8.0);
	float sum1=sumPoly2(In.Tex.xy,0);
	float sum2=sumPoly2(In.Tex.xy,2);
	float sum3=sumPoly2(In.Tex.xy,4);
	float sum4=sumPoly2(In.Tex.xy,6);
	return float4(sum1,sum2,sum3,sum4);
}
float4 PS_sum4(VS_OUTPUT In):COLOR0
{
	pixel=float2(1/2.0,1/4.0);
	float2 coord=In.Tex.xy;
	float sum1=sumPoly2(coord,0);
	coord.y+=2*pixel.y;
	float sum2=sumPoly2(coord,0);
	return float4(sum1,sum2,0,0);
}
static const int2 edges[12]={
	int2(0,1),
	int2(1,2),
	int2(2,3),
	int2(3,0),
	int2(4,5),
	int2(5,6),
	int2(6,7),
	int2(7,4),
	int2(0,4),
	int2(1,5),
	int2(2,6),
	int2(3,7)
};

static const float3 corners[8]={
	float3(0.f,0.f,0.f),
	float3(1.f,0.f,0.f),
	float3(1.f,0.f,1.f),
	float3(0.f,0.f,1.f),
	float3(0.f,1.f,0.f),
	float3(1.f,1.f,0.f),
	float3(1.f,1.f,1.f),
	float3(0.f,1.f,1.f)
};
static const float2 off[4]=
{
	{0,0},
	{1,0},
	{0,1},
	{1,1}
};


float2 gotoNextLevel(sampler map,float2 coord, int vertexIndex)
{
	float4 sumThis=floor(tex2Dlod(map,float4(coord,0,0))+0.001);
	float t=0;
	float minus=0;
	if(vertexIndex>=sumThis.x)
	{
		vertexIndex-=sumThis.x;
		minus+=sumThis.x;
		t=2;
		if(vertexIndex>=sumThis.y)
		{
			vertexIndex-=sumThis.y;
			minus+=sumThis.y;
			t=4;
			if(vertexIndex>=sumThis.z)
			{
				vertexIndex-=sumThis.z;
				minus+=sumThis.z;
				t=6;
				if(vertexIndex>=sumThis.w)
				{
					vertexIndex-=sumThis.w;
					minus+=sumThis.w;
					t=-1;
				}
			}
		}
		
	}
	return float2(t,minus);
}

float sampleDepthNew(float2 coord, float3 offset)
{
	float3 pixelD={1/4096.0,1/64.0,1/64.0};
	float pz=floor(coord.x*32);
	coord.y*=0.5;
	coord.y+=0.25;
	coord.x*=0.25;
	coord.x+=0.25;
	coord.x+=16*pixelD.x;
	coord.x+=pz*32*pixelD.x;
	
	coord.x+=offset.x*pixelD.x;
	coord.y+=offset.y*pixelD.y;
	coord.x+=floor(offset.z)*64*pixelD.x;
	return tex2Dlod(MapDepthSampler,float4(coord.xy,0,0)).x;
}
float4 PS_vertex(VS_OUTPUT In):COLOR0
{
	float2 pixel={1/1024.0,1/32.0};
	float2 pixel2={1/1024.0,1/32.0};
	//
	int vertexIndex=0;
	float2 coord=0;
	vertexIndex=floor(In.Tex.x*256.0+0.01);
	vertexIndex+=floor(floor(In.Tex.y*512.0+0.0001)*256.0+0.0001);
	int temp=vertexIndex;
	int vertexNum=floor(fmod(vertexIndex,3)+0.01);
	vertexIndex=floor(vertexIndex/3.0+0.01);
	coord=float2(0.0,0.0);
	int2 sum1=floor(tex2Dlod(Map4Sampler,float4(0.1,0.1,0,0)).xy+0.001);
	if(vertexIndex>=sum1.x)
	{
		vertexIndex-=sum1.x;
		coord.y+=0.5;
	}
	pixel=float2(1/2.0,1/4.0);
	pixel2=float2(1/16.0,1/8.0);
	float2 coordT=coord;
	int tt=-1;
	float2 level=0;
	for(int k=0; k<4 && tt<0; k++)
	{
		coord=coordT+off[k]*pixel;
		level=gotoNextLevel(Map3Sampler,coord,vertexIndex);
		tt=level.x;
		vertexIndex-=level.y;
		coord.x+=pixel2.x*max(0,tt);
	}
	pixel=float2(1/16.0,1/8.0);
	pixel2=float2(1/128.0,1/16.0);
	coordT=coord;		
	tt=-1;
	for(int l=0; l<4 && tt<0; l++)
	{
		coord=coordT+off[l]*pixel;
		level=gotoNextLevel(Map2Sampler,coord,vertexIndex);
		tt=level.x;
		vertexIndex-=level.y;
		coord.x+=pixel2.x*max(0,tt);
	}
	pixel=float2(1/128.0,1/16.0);
	pixel2=float2(1/1024.0,1/32.0);
	coordT=coord;	
	tt=-1;
	for(int m=0; m<4 && tt<0; m++)
	{
		coord=coordT+off[m]*pixel;
		level=gotoNextLevel(Map1Sampler,coord,vertexIndex);
		tt=level.x;
		vertexIndex-=level.y;
		coord.x+=pixel2.x*max(0,tt);
	}
	int sumI=floor(tex2Dlod(IndexSampler,float4(coord,0,0)).x*255.0+0.001);
	coordT=coord;
	if(vertexIndex>=sumI)
	{
		vertexIndex-=sumI;
		coord=coordT+float2(1/1024.0,0);
		sumI=floor(tex2Dlod(IndexSampler,float4(coord,0,0)).x*255.0+0.001);

		if(vertexIndex>=sumI)
		{
			vertexIndex-=sumI;
			coord=coordT+float2(0,1/32.0);
			sumI=floor(tex2Dlod(IndexSampler,float4(coord,0,0)).x*255.0+0.001);

			if(vertexIndex>=sumI)
			{
				vertexIndex-=sumI;
				coord=coordT+float2(1/1024.0,1/32.0);
			}
		}
	}
	float4 ma=tex2Dlod(IndexSampler,float4(coord,0,0));
	float marchIndex=ma.z*(1.0-1/511.0);
	float3 pos1=tex2Dlod(TriTableSampler,float4(marchIndex,((vertexIndex*3.0+vertexNum)*2)/31.0,0,0)).xyz;
	float3 pos2=tex2Dlod(TriTableSampler,float4(marchIndex,((vertexIndex*3.0+vertexNum)*2+1)/31.0,0,0)).xyz;
	float3 position=0;
	position.y=floor(coord.y*32.0+0.001);
	position.z=floor(coord.x*32.0+0.001);
	position.x=fmod(coord.x*1024.0,32.0);
	float p1=sampleDepthNew(coord,pos1);
	float p2=sampleDepthNew(coord,pos2);
	float mu;
	mu = saturate((-p1) / (p2 - p1));
	//	mu=0.5;
	position+=lerp(pos1,pos2,mu);//.zxy;
	position-=16;
	return float4(position,ma.y);
}
float4 getVertex(int index)
{
	float2 coord=0;
	coord.y=floor(index/256.0);
	coord.x=floor(fmod(index,256.0));
	coord.x/=256.0;
	coord.y/=512.0;
	return tex2Dlod(VertexSampler,float4(coord.xy,0,0));
}

float4 PS_vertexNormal(VS_OUTPUT In):COLOR0
{
	//	return tex2Dlod(VertexSampler,float4(In.Tex.xy,0,0));
	int vertexIndex=floor(In.Tex.x*256.0+0.001);
	vertexIndex+=floor(floor(In.Tex.y*512.0+0.001)*256.0+0.001);
	int temp=vertexIndex;
	int vertexNum=floor(fmod(vertexIndex,3)+0.01);
	vertexIndex=floor(vertexIndex/3+0.01);
	clip(g_numPolys-vertexIndex+1);
	int position=floor(fmod(In.Tex.x*512.0,2));
	float4 vertex=getVertex(vertexIndex*3+vertexNum);
	float4 vertex1=getVertex(vertexIndex*3);
	float4 vertex2=getVertex(vertexIndex*3+1);
	float4 vertex3=getVertex(vertexIndex*3+2);
	float3 vNormal;
	float3 v1, v2;
	v1=vertex2.xyz-vertex1.xyz;
	v2=vertex3.xyz-vertex1.xyz;
	vNormal=cross(v1,v2);
	vNormal=normalize(vNormal);	
	float4 final=0;
	final.xy=vNormal.yz;
	final.z=vertex.w;
	final.w=vertex.w;
	if(position==0)
	{
		final=vertex;
		final.w=vNormal.x;
	}
	return final;
}


technique createMapSlice
{
	pass P0
	{
		VertexShader = compile vs_3_0 VS();
		PixelShader  = compile ps_3_0 PS();
		AlphaBlendEnable = false;
		CullMode=None;
		//		        FillMode=2;
		//        
		//        PointSize=2;
	}
}


technique createCubes
{
	pass P0
	{
		VertexShader = compile vs_3_0 VS2();
		PixelShader  = compile ps_3_0 PS_Cube();
		AlphaBlendEnable = false;
		ZEnable=false;
		CullMode=None;
		//		        FillMode=2;
		//        
		//        PointSize=2;
	}
}


technique sum1
{
	pass P0
	{
		VertexShader = compile vs_3_0 VS_sum1();
		PixelShader  = compile ps_3_0 PS_sum1();
		AlphaBlendEnable = false;
		ZEnable=false;
		CullMode=None;
		//		        FillMode=2;
		//        
		//        PointSize=2;
	}
}
technique sum2
{
	pass P0
	{
		VertexShader = compile vs_3_0 VS_sum2();
		PixelShader  = compile ps_3_0 PS_sum2();
		AlphaBlendEnable = false;
		ZEnable=false;
		CullMode=None;
		//		        FillMode=2;
		//        
		//        PointSize=2;
	}
}
technique sum3
{
	pass P0
	{
		VertexShader = compile vs_3_0 VS_sum3();
		PixelShader  = compile ps_3_0 PS_sum3();
		AlphaBlendEnable = false;
		ZEnable=false;
		CullMode=None;
		//		        FillMode=2;
		//        
		//        PointSize=2;
	}
}
technique sum4
{
	pass P0
	{
		VertexShader = compile vs_3_0 VS_sum4();
		PixelShader  = compile ps_3_0 PS_sum4();
		AlphaBlendEnable = false;
		ZEnable=false;
		CullMode=None;
		//		        FillMode=2;
		//        
		//        PointSize=2;
	}
}

technique createVertex
{
	pass P0
	{
		VertexShader = compile vs_3_0 VS_vertex();
		PixelShader  = compile ps_3_0 PS_vertex();
		AlphaBlendEnable = false;
		ZEnable=false;
		CullMode=None;
		//		        FillMode=2;
		//        
		//        PointSize=2;
	}
}
technique createVertexNormal
{
	pass P0
	{
		VertexShader = compile vs_3_0 VS_vertex();
		PixelShader  = compile ps_3_0 PS_vertexNormal();
		AlphaBlendEnable = false;
		ZEnable=false;
		CullMode=None;
		//		        FillMode=2;
		//        
		//        PointSize=2;
	}
}

